var c, labor, y, k, tfp, ivst, A, Z, g, lamda, gv, psi;
varexo uA ug ugv upsi;


parameters beta del alpha eta b rhoA rhog rhoGv rhoPsi;

beta = 0.99;
del = 0.025;
alpha = 0.33;
eta = 1;
b = 0.8;
rhoA = 0.98;
rhog = 0.8226;
rhoGv = 0.95;
rhoPsi = 0.8;


model;
lamda = 1/(exp(c) - b*exp(c(-1))) - beta*b/(exp(c(+1)) - b*exp(c));
lamda*(1-exp(gv))*(1-alpha)*exp(y)/exp(labor) = exp(psi)*exp(labor)^(1/eta);
lamda = beta*lamda(+1)*(1-del+(1-exp(gv))*alpha*exp(y(+1))/exp(k));
exp(k) + exp(c) + exp(gv)*exp(y)= (1-del)*exp(k(-1)) + exp(y);
exp(tfp) = exp(A)*exp(Z);
exp(y) = exp(tfp)*exp(k(-1))^alpha*exp(labor)^(1-alpha);
exp(k) = (1-del)*exp(k(-1)) + exp(ivst);
A = rhoA*A(-1) + uA;
Z = g(-1) + 0.999*Z(-1);
g = rhog*g(-1) + ug;
gv = (1-rhoGv)*log(0.2) + rhoGv*gv(-1) + ugv;
psi = rhoPsi*psi(-1) + upsi;
end;


steady;


shocks;
var uA = 0.0075^2;
var ug = 0.0009785^2;
var ugv = 0.0015^2;
var upsi = 0.0015^2;
end;


stoch_simul(order=1, irf=21) tfp c y labor ivst k;

