function [ys,check] = jinnaiJMCB_one_sector_steadystate(ys,exe)
global M_


beta = M_.params(1);
del = M_.params(2);
alpha = M_.params(3);
eta = M_.params(4);
b = M_.params(5);



check = 0;


kY = (1-0.2)*alpha/(1/beta - 1 + del);
cY = 1 - del*kY - 0.2;
LSS = ((1 - beta*b)*(1-0.2)*(1-alpha)/((1-b)*cY))^(1/(1+1/eta));
ySS = (kY)^(alpha/(1-alpha))*LSS;


c = log(cY*ySS);
labor = log(LSS);
y = log(ySS);
k = log(kY*ySS);
ivst = log(del*kY*ySS);
tfp = 0;
lamda = (1 - beta*b)/((1-b)*cY*ySS);
A = 0;
Z = 0;
g = 0;
gv = log(0.2);
psi = 0;


ys =[
    c
    labor
    y
    k
    tfp
    ivst
    A
    Z
    g
    lamda
    gv
    psi
    ];