var c, labor, y, k, tfp, ivst, A, S, lamda, nI, nE, nt, d, v vhat, x, ti, tv, gv, psi;
varexo uA uS ugv upsi;


parameters beta b eta delK alpha delN theta sigma nu rhoA rhoS rhoGv rhoPsi;

beta = 0.99;
b = 0.8;
eta = 1;
delK = 0.025;
alpha = 0.33;

delN = 0.025;
theta = 3.8;


sigma = 1/80;
nu = 0.174936;

rhoA = 0.9777;
rhoS = 0.8056;
rhoGv = 0.95;
rhoPsi = 0.8;




model;
# Sss = ((1-sigma)*delN/(1-(1-sigma)*(1-delN)))^(nu-1)*delN/(1-delN);
exp(y) = exp(tfp)*exp(k(-1))^alpha*exp(labor)^(1-alpha);
exp(tfp) = exp(A)*exp(nt(-1))^(1/(theta-1))*
(exp(nI(-1)) + (1-exp(nI(-1)))*(theta/(theta-1))^(theta-1))^(theta/(theta-1))*
(exp(nI(-1)) + (1-exp(nI(-1)))*(theta/(theta-1))^theta)^-1;
lamda = 1/(exp(c) - b*exp(c(-1))) - beta*b/(exp(c(+1)) - b*exp(c));
lamda*(1-exp(gv))*(1-alpha)*(exp(y)-exp(d))/exp(labor) = exp(psi)*exp(labor)^(1/eta);
lamda = beta*lamda(+1)*(1 - delK + (1-exp(gv(+1)))*alpha*(exp(y(+1)) - exp(d(+1)))/exp(k));
exp(k) = (1-delK)*exp(k(-1)) + exp(ivst);
exp(x) = nu*(1-sigma)*exp(nE)/exp(nI)*(exp(v) + exp(vhat));
lamda*exp(v) = beta*lamda(+1)*((1-exp(gv(+1)))*exp(d(+1)) + (1-(1-sigma)*exp(nE(+1))/exp(nI(+1)))*exp(v(+1)));
lamda*exp(vhat) = beta*lamda(+1)*((1-nu)/nu*exp(x(+1)) + (1-(1-sigma)*exp(nE(+1))/exp(nI(+1)))*exp(vhat(+1)));
exp(d) = (1/theta)*exp(y)*exp(nI(-1))*(exp(nI(-1)) + (1-exp(nI(-1)))*(theta/(theta-1))^(theta-1))^-1;
exp(nE)/(1-exp(nE)) = exp(S)*exp(nI(-1))^(1-nu)*(exp(x)/exp(nt(-1)))^nu;
exp(nI) = (1-sigma)*(exp(nI(-1)) + exp(nE)*(1 - exp(nI(-1))));
exp(nt)/exp(nt(-1)) = (1-delN)/(1-exp(nE));
(1 - exp(gv))*exp(y)= exp(c) + exp(ivst) + exp(x);
exp(ti) = exp(ivst) + exp(x);
exp(tv) = exp(k) + exp(v) + exp(vhat);
A = rhoA*A(-1) + uA;
S - log(Sss) = rhoS*(S(-1) - log(Sss)) + uS;
gv = (1-rhoGv)*log(0.2) + rhoGv*gv(-1) + ugv;
psi = rhoPsi*psi(-1) + upsi;
end;


steady;


shocks;
var uA = 0.0075^2;
var uS = 0.091^2;
var ugv = 0.0015^2;
var upsi = 0.0015^2;
end;



stoch_simul(order=1, irf=21) tfp c y labor ti tv;